Attribute VB_Name = "modFunciones"
Option Explicit

Public Function mezclarParpadeo(strBin As String) As String
'Devuelve una cadena con las luces encendidas que hubiese ms la naranja (del botn izquierdo apretado) si esta estuviese activa
If blnIzquierdoApretado Then
  mezclarParpadeo = bin(dec("11000000") Or dec(strBin))
Else
  mezclarParpadeo = bin(dec("10000000") Or dec(strBin))
End If
End Function


Public Function bin(intN As Integer) As String
'Devuelve una cadena con el binario correspondiente a su argumento (decimal)
Dim intIndice As Integer
bin = "00000000"
If (intN < 0) Or (intN > 255) Then
  bin = "22222222"
Else
  intIndice = 8
  Do While (intN > 1)
    If (intN / 2) <> Int(intN / 2) Then Mid(bin, intIndice, 1) = "1"
    intIndice = intIndice - 1
    intN = Int(intN / 2)
  Loop
  If intN = 1 Then Mid(bin, intIndice, 1) = "1"
End If
End Function


Public Function dec(strN As String) As Integer
'Devuelve un nmero correspondiente al decimal de su argumento (binario como cadena)
Dim intPotencia, intNumero, intIndice As Integer
If (Len(strN) = 8) Then
  intPotencia = 1
  intNumero = 0
  For intIndice = 8 To 1 Step -1
    If Mid(strN, intIndice, 1) = "1" Then intNumero = intNumero + intPotencia
    intPotencia = intPotencia * 2
  Next intIndice
  dec = intNumero
Else
  dec = -1
End If
End Function

