Attribute VB_Name = "modSubClas"
Option Explicit

' Este mdulo se necesita, junto con "modIconBar", para crear el cono
' en el systray.
' El nico procedimiento que puede necesitar ser modificado es el
' ltimo ("ProcesarEventoIcon")
' Para poner el cono, en el evento "Load" del formulario van las sig. 2 lneas:
'   "MostrarIcono"
'   "ActivarSubclas Me.hwnd"
' y para sacar el cono, en el evento "UnLoad" del formulario, las sig.:
'   "OcultarIcono"
'   "DesactivarSubclas Me.hwnd"


' Mdulo Subclas.bas
'-------------------

' Mensajes generados al actuar sobre el icono y que
' deseamos procesar
Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_RBUTTONDOWN = &H204

' Subclasificacin
Public Declare Function SetWindowLong Lib "user32" Alias _
  "SetWindowLongA" (ByVal hwnd As Long, _
  ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Declare Function CallWindowProc Lib "user32" Alias _
  "CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
  ByVal hwnd As Long, ByVal Msg As Long, _
  ByVal wParam As Long, ByVal lParam As Long) As Long

Public Const GWL_WNDPROC = -4
Public lpProcVentAnt As Long ' procedimiento de ventana anterior


Public Sub ActivarSubclas(hVentSubcla As Long)
  lpProcVentAnt = SetWindowLong(hVentSubcla, GWL_WNDPROC, _
                                AddressOf WindowProc)
End Sub

Public Sub DesactivarSubclas(hVentSubcla As Long)
  lpProcVentAnt = SetWindowLong(hVentSubcla, GWL_WNDPROC, _
                                lpProcVentAnt)
End Sub

Public Function WindowProc(ByVal hwnd As Long, _
                    ByVal uMsg As Long, ByVal wParam As Long, _
                    ByVal lParam As Long) As Long
  ' Ejecutar el procedimiento de ventana predeterminado
  WindowProc = CallWindowProc(lpProcVentAnt, _
                              hwnd, uMsg, wParam, lParam)
  ' Interceptar el mensaje WM_NOTIFYICON
  If uMsg = WM_NOTIFYICON And lParam <> WM_MOUSEMOVE Then
    ProcesarEventoIcon wParam, lParam
  End If
End Function

Public Sub ProcesarEventoIcon(ByVal wParam As Long, ByVal lParam As Long)
If ((blnOpcionesAbierta = False) And (blnAgregarUsuarioAbierta = False) And (blnSalirAbierta = False)) Then
'Controlo esto porque sino da un error y se cierra al hacer click en systray con alguna ventana abierta
Select Case lParam
  Case WM_LBUTTONDOWN
      frmMPB.Visible = True
        If (blnFlechasAbierta = True) Then  'Para que al hacer click en systray cierre la ventana de las flechas (si estuviera abierta)
          Unload frmFlechas
        End If
      frmMPB.cmdAceptar.SetFocus
  Case WM_LBUTTONDBLCLK
      frmMPB.Visible = True
        If (blnFlechasAbierta = True) Then  'Para que al hacer click en systray cierre la ventana de las flechas (si estuviera abierta)
          Unload frmFlechas
        End If
      frmMPB.cmdAceptar.SetFocus
  Case WM_RBUTTONDOWN
      frmMPB.Visible = True
        If (blnFlechasAbierta = True) Then  'Para que al hacer click en systray cierre la ventana de las flechas (si estuviera abierta)
          Unload frmFlechas
        End If
      frmMPB.cmdAceptar.SetFocus
End Select
End If
End Sub
