Attribute VB_Name = "modIconBar"
Option Explicit

' Este mdulo se necesita, junto con "subClas", para crear el cono
' en el systray.
' El nico procedimiento que puede necesitar ser modificado es el
' ltimo ("MostrarIcono"), en donde habr que reemplazar el nombre del
' formulario ("frmMPB") por el que corresponda, y la lnea
' "stIconData.szTip = "MPB" & vbNullChar".


' Mdulo modIconBar.bas
' ---------------------

Private Type NOTIFYICONDATA
  cbSize As Long
  hwnd As Long
  uId As Long
  uFlags As Long
  uCallBackMessage As Long
  hIcon As Long
  szTip As String * 64
End Type

' Tipo de operacin que podemos realizar con el icono
Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2

' Indicar qu campos son vlidos en NOTIFYICONDATA
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4

' Declaracin de Shell_NotifyIcon
Private Declare Function Shell_NotifyIcon Lib "shell32" Alias _
  "Shell_NotifyIconA" (ByVal dwMessage As Long, _
  lpData As NOTIFYICONDATA) As Boolean

' Identificador del mensaje definido por la aplicacin
Public Const WM_APP = &H8000& ' Long (&) para que no sea negativo
Public Const WM_NOTIFYICON = WM_APP + 100 ' mensaje

' Variable para contener los datos asociados con el icono
Private stIconData As NOTIFYICONDATA

' Variable que indica si el icono se est mostrando
Private IconoMostrado As Boolean


Public Sub OcultarIcono()
 ' Eliminar el icono
  IconoMostrado = Not (Shell_NotifyIcon(NIM_DELETE, stIconData) _
                       Or Not IconoMostrado)
End Sub

Public Sub MostrarIcono()
  ' Llenar la estructura stIconData necesaria para Shell_NotifyIcon

  ' Tamao de la estructura
  stIconData.cbSize = Len(stIconData)
  
  ' handle de la ventana que recibe el mensaje del icono
  stIconData.hwnd = frmMPB.hwnd

  ' Identificador del icono
  stIconData.uId = frmMPB.hwnd ' o simplemente vbNull

  ' Todos los campos son vlidos
  stIconData.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE

  ' Mensaje que se mandar a la ventana principal
  stIconData.uCallBackMessage = WM_NOTIFYICON

  ' Icono a utilizar
  stIconData.hIcon = frmMPB.Icon

  ' Descripcin breve
  stIconData.szTip = "MPB" & vbNullChar

  ' Llamar a Shell_NotifyIcon para aadir el icono
  IconoMostrado = Shell_NotifyIcon(NIM_ADD, stIconData)
End Sub
